" vi:set ts=8 sts=2 sw=2 tw=0:
"
" eblook.vim - lookup EPWING dictionary using `eblook' command.
"
" Maintainer: KIHARA Hideto <deton@m1.interq.or.jp>
" Revision: $Id: eblook.vim,v 1.27 2003/12/06 04:27:50 deton Exp $

scriptencoding cp932

" Description:
"   `eblook'vOgEPWING/dqubNB
"   ̃XNvgg߂ɂ́A
"   `eblook'vO<http://openlab.jp/edict/eblook/>EPWINGKvB
"
"   <Leader><C-Y>Č͂ƁAʂentryEBhE
"   contentEBhEɕ\B
"
" R}h:
"   :EblookSearch       w肵P̌s
"   :EblookListDict     ̈ꗗ\
"   :EblookSkipDict     w肵ԍ̎ꎞIɌΏۂO
"   :EblookNotSkipDict  w肵ԍ̎ꎞIɌΏۂɓ
"
" nmap:
"   <Leader><C-Y>       P͂Čs
"   <Leader>y           J[\ʒuɂP
"
" entryobt@nmap
"   <CR>                J[\sentryɑΉcontent\
"   J                   J[\̍sɈړcontent\
"   K                   J[\̍sɈړcontent\
"   <Space>             contentEBhEPageDowns
"   <BS>                contentEBhEPageUps
"   q                   entryEBhEcontentEBhE
"   s                   VP͂Č(<Leader><C-Y>Ɠ)
"   p                   contentEBhEɈړ
"   R                   referenceꗗ\
"   <C-P>               𒆂̈Õobt@\
"   <C-N>               𒆂̈̃obt@\
"
" contentobt@nmap
"   <CR>                J[\ʒureference\
"   <Space>             PageDowns
"   <BS>                PageUps
"   <Tab>               referenceɃJ[\ړ
"   q                   entryEBhEcontentEBhE
"   s                   VP͂Č(<Leader><C-Y>Ɠ)
"   p                   entryEBhEɈړ
"   R                   referenceꗗ\
"   <C-P>               𒆂̈Õobt@\
"   <C-N>               𒆂̈̃obt@\
"
" IvV:
"    'eblook_dict{n}_title'
"    'eblook_dict{n}_book'
"    'eblook_dict{n}_name'
"    'eblook_dict{n}_skip'
"       EPWING̐ݒB{n}1, 2, 3, ...Bgw肷B
"       Ŏw肵(ԍ)̏ɌsB
"       ͘AĂKvB
"       eblook_dict{n}_skipȊO͕K{B
"
"      'eblook_dict{n}_title'
"         ̎ʎqwBentryEBhEŎʂ邽߂ɎgB
"         (eblook.vimł͎ԍtitleŎʂB)
"         ʂ邽߂ɎgȂ̂ŁA
"         ̎ƂԂȂKɂB
"         :
"           let eblook_dict1_title = 'Lܔ'
"
"      'eblook_dict{n}_book'
"         eblookvO`book'R}hɓnp[^B
"         ̂fBNg(catalogst@ĈfBNg)wB
"         Appendixꍇ́A
"         fBNgɑAppendixfBNgwB
"         :
"           let eblook_dict1_book = '/usr/local/epwing'
"
"      'eblook_dict{n}_name'
"         eblookvO`select'R}hɓnp[^B
"         wBeblookvOlistR}hŒׂB
"         :
"           let eblook_dict1_name = 'kojien'
"
"      'eblook_dict{n}_skip'
"         0łȂlݒ肷ƁA̎͌ȂB
"         :
"           let eblook_dict1_skip = 1
"
"
"    'eblook_history_max'
"       ێĂߋ̌obt@̏Bȗl: 10
"
"    'mapleader'
"       L[}bsÕvtBbNXB|mapleader|QƁBȗl: CTRL-K
"       CTRL-Kw肷ꍇ̗:
"         let mapleader = "\<C-K>"
"
"    'plugin_eblook_disable'
"       ̃vOCǂݍ݂ȂꍇɎ̂悤ɐݒ肷B
"         let plugin_eblook_disable = 1

if exists('plugin_eblook_disable')
  finish
endif

" ێĂߋ̌obt@̏
if !exists('eblook_history_max')
  let eblook_history_max = 10
endif

command! -nargs=1 EblookSearch call <SID>Search(<q-args>)
command! EblookListDict call <SID>ListDict()
command! -nargs=* EblookSkipDict call <SID>SetDictSkip(1, <f-args>)
command! -nargs=* EblookNotSkipDict call <SID>SetDictSkip(0, <f-args>)

" </reference=>Ŏw肳entrypattern
let s:refpat = '[[:xdigit:]]\+:[[:xdigit:]]\+'
" eblookɃ_CNgR}hێꎞt@C
let s:cmdfile = tempname()
" entryobt@̃x[X
let s:entrybufname = fnamemodify(s:cmdfile, ':p:h') . '/_eblook_entry_'
let s:entrybufname = substitute(s:entrybufname, '\\', '/', 'g')
" contentobt@̃x[X
let s:contentbufname = fnamemodify(s:cmdfile, ':p:h') . '/_eblook_content_'
let s:contentbufname = substitute(s:contentbufname, '\\', '/', 'g')
" obt@qXǧ݈ʒu
let s:bufindex = 0

" }bsO
let s:set_mapleader = 0
if !exists('g:mapleader')
  let g:mapleader = "\<C-K>"
  let s:set_mapleader = 1
endif
nnoremap <silent> <Leader><C-Y> :<C-U>call <SID>SearchInput()<CR>
nnoremap <silent> <Leader>y :<C-U>call <SID>Search(expand('<cword>'))<CR>
if s:set_mapleader
  unlet g:mapleader
endif
unlet s:set_mapleader

augroup Eblook
autocmd!
execute "autocmd BufReadCmd " . s:entrybufname . "* call <SID>Empty_BufReadCmd()"
execute "autocmd BufReadCmd " . s:contentbufname . "* call <SID>Empty_BufReadCmd()"
execute "autocmd BufEnter " . s:entrybufname . "* call <SID>Entry_BufEnter()"
execute "autocmd BufEnter " . s:contentbufname . "* call <SID>Content_BufEnter()"
augroup END

" titleݒ肳ĂȂAԍnameݒ肵Ă
let s:i = 1
while exists("g:eblook_dict{s:i}_name")
  if !exists("g:eblook_dict{s:i}_title")
    let g:eblook_dict{s:i}_title = s:i . g:eblook_dict{s:i}_name
  endif
  let s:i = s:i + 1
endwhile
unlet s:i

" entryobt@ɓɎsBset nobuflistedB
function! s:Entry_BufEnter()
  set buftype=nofile
  set bufhidden=hide
  set noswapfile
  set nobuflisted
  nnoremap <buffer> <silent> <CR> :call <SID>GetContent()<CR>
  nnoremap <buffer> <silent> J j:call <SID>GetContent()<CR>
  nnoremap <buffer> <silent> K k:call <SID>GetContent()<CR>
  nnoremap <buffer> <silent> <Space> :call <SID>ScrollContent(1)<CR>
  nnoremap <buffer> <silent> <BS> :call <SID>ScrollContent(0)<CR>
  nnoremap <buffer> <silent> p :call <SID>GoWindow(0)<CR>
  nnoremap <buffer> <silent> q :call <SID>Quit()<CR>
  nnoremap <buffer> <silent> R :call <SID>ListReferences()<CR>
  nnoremap <buffer> <silent> s :call <SID>SearchInput()<CR>
  nnoremap <buffer> <silent> <C-P> :call <SID>History(-1)<CR>
  nnoremap <buffer> <silent> <C-N> :call <SID>History(1)<CR>
  execute 'nnoremap <buffer> <silent> <Tab> /' . s:refpat . '<CR>'
endfunction

" contentobt@ɓɎsBset nobuflistedB
function! s:Content_BufEnter()
  set buftype=nofile
  set bufhidden=hide
  set noswapfile
  set nobuflisted
  nnoremap <buffer> <silent> <CR> :call <SID>SelectReference()<CR>
  nnoremap <buffer> <silent> <Space> <PageDown>
  nnoremap <buffer> <silent> <BS> <PageUp>
  nnoremap <buffer> <silent> <Tab> /<reference/<CR>
  nnoremap <buffer> <silent> p :call <SID>GoWindow(1)<CR>
  nnoremap <buffer> <silent> q :call <SID>Quit()<CR>
  nnoremap <buffer> <silent> R :call <SID>FollowReference('')<CR>
  nnoremap <buffer> <silent> s :call <SID>SearchInput()<CR>
  nnoremap <buffer> <silent> <C-P> :call <SID>History(-1)<CR>:call <SID>GoWindow(0)<CR>
  nnoremap <buffer> <silent> <C-N> :call <SID>History(1)<CR>:call <SID>GoWindow(0)<CR>
endfunction

" vvgoāA[U͂ꂽ
function! s:SearchInput()
  let str = input('eblook: ')
  if strlen(str) == 0
    return
  endif
  call s:Search(str)
endfunction

" w肳ꂽP̌sB
" entryobt@Ɍʂ̃Xg\A
" ̂擪entry̓econtentobt@ɕ\B
" @param key P
function! s:Search(key)
  let hasoldwin = bufwinnr(s:entrybufname . s:bufindex)
  if hasoldwin < 0
    let hasoldwin = bufwinnr(s:contentbufname . s:bufindex)
  endif
  call s:NewBuffers()
  execute 'redir! >' . s:cmdfile
  let prev_book = ''
  let i = 1
  while exists("g:eblook_dict{i}_name")
    if exists("g:eblook_dict{i}_skip") && g:eblook_dict{i}_skip
      let i = i + 1
      continue
    endif
    let dname = g:eblook_dict{i}_name
    if exists("g:eblook_dict{i}_book") && g:eblook_dict{i}_book !=# prev_book
      silent echo 'book ' . g:eblook_dict{i}_book
      let prev_book = g:eblook_dict{i}_book
    endif
    silent echo 'select ' . dname
    silent echo 'set prompt "eblook-' . dname . '> "'
    silent echo 'search "' . a:key . "\"\n"
    let i = i + 1
  endwhile
  redir END
  silent execute 'read! ++enc=' . &enc . ' eblook < ' . s:cmdfile

  silent! :g/^Warning: you should specify a book directory first$/d
  silent! :%s/eblook.*> \(eblook.*> \)/\1/g
  let i = 1
  while exists("g:eblook_dict{i}_name")
    let dname = g:eblook_dict{i}_name
    let title = g:eblook_dict{i}_title
    silent! execute ':1/eblook-' . dname . '/;/^eblook/-1s/^/' . title . "\t"
    let i = i + 1
  endwhile
  silent! :%s/eblook.*> //g
  silent! :g/^$/d
  normal! 1G
  if s:GetContent() < 0
    let v:errmsg = ''
    silent! :%s/./&/g
    if strlen(v:errmsg) > 0
      bwipeout!
      silent! call s:History(-1)
      if hasoldwin < 0
	call s:Quit()
      endif
      redraw | echomsg 'eblook-vim: ܂ł: <' . a:key . '>'
    endif
  endif
endfunction

" Vs߂ɁAentryobt@contentobt@B
function! s:NewBuffers()
  " entryobt@contentobt@͈΂ňB
  let oldindex = s:bufindex
  let s:bufindex = s:NextBufIndex()
  call s:CreateBuffer(s:entrybufname, oldindex)
  call s:CreateBuffer(s:contentbufname, oldindex)
  execute "normal! \<C-W>p4\<C-W>_"
endfunction

" entryobt@contentobt@̂ꂩ
" @param bufname s:entrybufnames:contentbufnamêꂩ
" @param oldindex ݂entry,contentobt@̃CfbNXԍ
function! s:CreateBuffer(bufname, oldindex)
  let oldbufname = a:bufname . a:oldindex
  let newbufname = a:bufname . s:bufindex
  if bufexists(newbufname)
    let bufexists = 1
  else
    let bufexists = 0
  endif
  if s:SelectWindowByName(oldbufname) < 0
    execute "silent normal! :split " . newbufname . "\<CR>"
  else
    execute "silent normal! :edit " . newbufname . "\<CR>"
  endif
  if bufexists
    silent execute "normal! :%d\<CR>"
  endif
endfunction

" entryobt@̃J[\sɑΉecontentobt@ɕ\
" @return -1:content\s, 0:\
function! s:GetContent()
  let str = getline('.')
  let title = matchstr(str, '^[^\t]\+')
  if strlen(title) == 0
    return -1
  endif
  let dnum = s:GetDictNumFromTitle(title)
  if dnum <= 0
    return -1
  endif
  let refid = matchstr(str, s:refpat)
  if strlen(refid) == 0
    return -1
  endif

  if s:SelectWindowByName(s:contentbufname . s:bufindex) < 0
    execute "silent normal! :split " . s:contentbufname . s:bufindex . "\<CR>"
  endif

  silent execute "normal! :%d\<CR>"
  let b:dictnum = dnum
  execute 'redir! >' . s:cmdfile
  if exists("g:eblook_dict{b:dictnum}_book")
    silent echo 'book ' . g:eblook_dict{b:dictnum}_book
  endif
  silent echo 'select ' . g:eblook_dict{b:dictnum}_name
  silent echo 'content ' . refid . "\n"
  redir END
  silent execute 'read! ++enc=' . &enc . ' eblook < ' . s:cmdfile

  silent! :g/^Warning: you should specify a book directory first$/d
  silent! :%s/eblook> //g
  silent! :g/^$/d
  normal! 1G
  execute "normal! \<C-W>p"
  return 0
endfunction

" contentobt@̃J[\ʒut߂<reference>𒊏oāA
" ̓e\B
function! s:SelectReference()
  let str = getline('.')
  let refid = matchstr(str, s:refpat)
  let m1 = matchend(str, s:refpat)
  if m1 < 0
    return
  endif
  " <reference>1s2ȏ゠ꍇ́AJ[\ʒug
  let m2 = match(str, s:refpat, m1)
  if m2 >= 0
    let col = col('.')
    let offset = strridx(strpart(str, 0, col), '<')
    if offset >= 0
      let refid = matchstr(str, refpat, offset)
    endif
  endif
  if strlen(refid) == 0
    return
  endif
  call s:FollowReference(refid)
endfunction

" entryobt@ŃJ[\s̃GgɊ܂܂<reference>̃Xg\
function! s:ListReferences()
  call s:GetContent()
  call s:FollowReference('')
endfunction

" <reference>XgAbventryobt@ɕ\A
" w肳ꂽ<reference>̓econtentobt@ɕ\B
" @param refid \eB''̏ꍇ̓Xg̍ŏ̂̂\
function! s:FollowReference(refid)
  if s:SelectWindowByName(s:contentbufname . s:bufindex) < 0
    execute "silent normal! :split " . s:contentbufname . s:bufindex . "\<CR>"
  endif
  let dnum = b:dictnum
  let save_line = line('.')
  let save_col = col('.')
  " ggŃobt@擪ɈړĂsearch()ŌƁA
  " obt@`̌ΏەɃqbgȂ̂ŁAwrap aroundČ
  normal! G$
  let searchflag = 'w'
  let i = 1
  while search('<reference>', searchflag) > 0
    let line = getline('.')
    let col = col('.') - 1
    let label{i} = matchstr(line, '<reference>\zs.\{-}\ze</reference', col)
    let entry{i} = matchstr(line, s:refpat, col)
    let i = i + 1
    let searchflag = 'W'
  endwhile
  if i <= 1
    return
  endif
  execute 'normal! ' . save_line . 'G' . save_col . '|'

  call s:NewBuffers()
  let j = 1
  while j < i
    execute 'normal! o' . g:eblook_dict{dnum}_title . "\<Tab>" . entry{j} . "\<Tab>" . label{j} . "\<Esc>"
    let j = j + 1
  endwhile
  silent! :g/^$/d

  normal! gg
  if strlen(a:refid) > 0
    execute 'normal! /' . a:refid . "\<CR>"
  endif
  call s:GetContent()
endfunction

" obt@̃qXgǂB
" @param dir -1:Â, 1:V
function! s:History(dir)
  if a:dir > 0
    let ni = s:NextBufIndex()
    if !bufexists(s:entrybufname . ni) || !bufexists(s:contentbufname . ni)
      echomsg 'eblook-vim: ̃obt@͂܂'
      return
    endif
  else
    let ni = s:PrevBufIndex()
    if !bufexists(s:entrybufname . ni) || !bufexists(s:contentbufname . ni)
      echomsg 'eblook-vim: Õobt@͂܂'
      return
    endif
  endif
  if s:SelectWindowByName(s:entrybufname . s:bufindex) < 0
    execute "silent normal! :split " . s:entrybufname . ni . "\<CR>"
  else
    execute "silent normal! :edit " . s:entrybufname . ni . "\<CR>"
  endif
  if s:SelectWindowByName(s:contentbufname . s:bufindex) < 0
    execute "silent normal! :split " . s:contentbufname . ni . "\<CR>"
  else
    execute "silent normal! :edit " . s:contentbufname . ni . "\<CR>"
  endif
  execute "normal! \<C-W>p"
  let s:bufindex = ni
endfunction

" ̃obt@̃CfbNXԍԂ
" @return ̃obt@̃CfbNXԍ
function! s:NextBufIndex()
  let i = s:bufindex + 1
  if i > g:eblook_history_max
    let i = 1
  endif
  return i
endfunction

" Õobt@̃CfbNXԍԂ
" @return Õobt@̃CfbNXԍ
function! s:PrevBufIndex()
  let i = s:bufindex - 1
  if i < 1
    let i = g:eblook_history_max
  endif
  return i
endfunction

" entryEBhEcontentEBhEB
function! s:Quit()
  if s:SelectWindowByName(s:contentbufname . s:bufindex) >= 0
    hide
  endif
  if s:SelectWindowByName(s:entrybufname . s:bufindex) >= 0
    hide
  endif
endfunction

" entryEBhEcontentEBhEXN[B
" @param down 1̏ꍇɁA0̏ꍇɁB
function! s:ScrollContent(down)
  call s:GoWindow(0)
  if a:down
    execute "normal! \<PageDown>"
  else
    execute "normal! \<PageUp>"
  endif
  execute "normal! \<C-W>p"
endfunction

" entryEBhE/contentEBhEɈړ
" @param to_entry_buf 1:entryEBhEɈړ, 0:contentEBhEɈړ
function! s:GoWindow(to_entry_buf)
  if a:to_entry_buf
    let bufname = s:entrybufname . s:bufindex
  else
    let bufname = s:contentbufname . s:bufindex
  endif
  if s:SelectWindowByName(bufname) < 0
    execute "silent normal! :split " . bufname . "\<CR>"
  endif
endfunction

" title񂩂玫ԍԂ
" @param title title
" @return ԍ
function! s:GetDictNumFromTitle(title)
  let i = 1
  while exists("g:eblook_dict{i}_title")
    if a:title ==# g:eblook_dict{i}_title
      return i
    endif
    let i = i + 1
  endwhile
  return -1
endfunction

" ꗗ\
function! s:ListDict()
  let i = 1
  while exists("g:eblook_dict{i}_name")
    let skip = ''
    if exists("g:eblook_dict{i}_skip") && g:eblook_dict{i}_skip
      let skip = 'skip'
    endif
    let title = g:eblook_dict{i}_title
    let dname = g:eblook_dict{i}_name
    let book = ''
    if exists("g:eblook_dict{i}_book")
      let book = g:eblook_dict{i}_book
    endif
    echo skip . "\t" . i . "\t" . title . "\t" . dname . "\t" . book
    let i = i + 1
  endwhile
endfunction

" XLbv邩ǂꎞIɐݒ肷B
" @param is_skip XLbv邩ǂB1:XLbv, 0:XLbvȂ
" @param ... ԍ̃Xg
function! s:SetDictSkip(is_skip, ...)
  let i = 1
  while i <= a:0
    if a:is_skip
      let g:eblook_dict{a:{i}}_skip = 1
    else
      unlet! g:eblook_dict{a:{i}}_skip
    endif
    let i = i + 1
  endwhile
endfunction

" SelectWindowByName(name)
"   Acitvate selected window by a:name.
function! s:SelectWindowByName(name)
  let num = bufwinnr(a:name)
  if num >= 0 && num != winnr()
    execute 'normal! ' . num . "\<C-W>\<C-W>"
  endif
  return num
endfunction

" ̃obt@
function! s:Empty_BufReadCmd()
endfunction
